/* henon1 -- try for a henon attractor graph -- BGG 9/2003
*/

#include "wx/wxprec.h"

#ifndef WX_PRECOMP
	#include "wx/wx.h"
#endif

#include "henon1.h"
#include <iostream.h>

#define MAIN		/* So RTcmix globals will be right */
#include <globals.h>
#include <RTcmix.h>


IMPLEMENT_APP(henon1)

bool henon1::OnInit()
{
	wxFrame *frame = new wxFrame((wxFrame*) NULL, -1, "henon1",
		wxPoint(50, 50), wxSize(500, 400),
		wxDEFAULT_FRAME_STYLE, "henon1");
	frame->Show(TRUE);
	SetTopWindow(frame);

	wxButton *button = new wxButton(frame, BUTTON_HIT, "realize!",
		wxPoint(100, 350), wxSize(70, 20));

	wdc = new wxClientDC(frame);

	return true;
}

void henon1::OnButton(wxCommandEvent& command)
{
	x = 0.0;
	y = 0.0;

	attract(10000);
}

void henon1::attract(int ntimes)
{
	double a, b;
	double xnew, ynew;
	int i;
	int px, py;

	a = 7.0/5.0;
	b = 0.3;
	wdc->SetPen(*wxBLACK_PEN);
	for (i = 0; i < ntimes; i++)
	{
		xnew = y - (a*(x*x)) + 1.0;
		ynew = b * x;

		px = (int)((x + 2.0) * 150.0);
		py = (int)((y + 0.4) * 400.0);
		wdc->DrawPoint(px, py);

		x = xnew;
		y = ynew;
	}
}


BEGIN_EVENT_TABLE(henon1, wxApp)
	EVT_BUTTON(BUTTON_HIT, henon1::OnButton)
END_EVENT_TABLE()

