/* myTimer -- the timing object for doing lorenz graph-timing -- BGG 9/2003
*/

#include "wx/wxprec.h"

#ifndef WX_PRECOMP
	#include "wx/wx.h"
#endif

#include "myTimer.h"
#include <iostream.h>


myTimer::myTimer(wxFrame *fr)
{
	// the graphics context (for drawing) and the RTcmix object
	// are set in the calling program
	theFrame = fr;

	x = 0.0;
	y = 0.0;
	a = 7.0/5.0;
	b = 0.3;
	ntimes = 20;
}

void myTimer::Notify()
{
// this is where the work is done -- Notify() is called periodically
	double xnew, ynew;
	int i;
	int px, py;
	wxClientDC *wdc;

	wdc = new wxClientDC(theFrame);

	wdc->SetPen(*wxBLACK_PEN);
	for (i = 0; i < ntimes; i++)
	{
		xnew = y - (a*(x*x)) + 1.0;
		ynew = b * x;

		px = (int)((x + 2.0) * 150.0);
		py = (int)((y + 0.4) * 400.0);
		wdc->DrawPoint(px, py);

		x = xnew;
		y = ynew;
	}
}

