/* myTimer -- the timing object for doing lorenz graph-timing -- BGG 9/2003
*/

#include "wx/wxprec.h"

#ifndef WX_PRECOMP
	#include "wx/wx.h"
#endif

#include "myTimer.h"
#include <iostream.h>


myTimer::myTimer(wxFrame *fr)
{
	int i, j;

	// the graphics context (for drawing) and the RTcmix object
	// are set in the calling program
	theFrame = fr;

	x = 0.0;
	y = 0.0;
	a = 7.0/5.0;
	b = 0.3;
	ntimes = 20;

	for (i = 0; i < 100; i++)
	{
		for (j = 0; j < 100; j++) hits[i][j] = 0;
	}

	rrr = new RTcmix(44100, 2, 1024);
//	rrr->printOn();
	rrr->cmd("load", 1, "WAVETABLE");
	rrr->cmd("makegen", 4, 1.0, 25.0, 1000.0, 1.0);
	rrr->cmd("makegen", 4, 2.0, 10.0, 1000.0, 1.0);
	rrr->cmd("reset", 1, 44100.0);
}

void myTimer::Notify()
{
// this is where the work is done -- Notify() is called periodically
	double xnew, ynew;
	double start;
	int i, j;
	int px, py;
	wxClientDC *wdc;

	wdc = new wxClientDC(theFrame);

	wdc->SetPen(*wxBLACK_PEN);
	for (i = 0; i < ntimes; i++)
	{
		xnew = y - (a*(x*x)) + 1.0;
		ynew = b * x;

		px = (int)((x + 2.0) * 150.0);
		py = (int)((y + 0.4) * 400.0);
		wdc->DrawPoint(px, py);

		if (px < 0) px = 0;
		if (py < 0) py = 0;
		if (px > 399) px = 399;
		if (py > 399) py = 399;
		px = px/4;
		py = py/4;
		hits[px][py] = 1;

		x = xnew;
		y = ynew;
	}

	start = 0.0;
	for (i = 0; i < 100; i++)
	{
		for (j = 0; j < 100; j++)
		{
			if (hits[i][j] == 1)
				rrr->cmd("WAVETABLE", 5, start, 0.05, 5000.0, (double)(900-(j*4)), 0.5);
		}
		start += 0.02;
	}
}

